package cn.estsh.i3plus.ext.mes.apiservice.controller.busi.bu3;

import cn.estsh.i3plus.ext.mes.api.busi.bu3.ISxWorkingTimeMonthlyPerformanceService;
import cn.estsh.i3plus.ext.mes.pojo.model.bu3.SxWorkingTimeMonthlyPerformanceModel;
import cn.estsh.i3plus.ext.mes.pojo.util.MesExtConstWords;
import cn.estsh.i3plus.platform.common.util.CommonConstWords;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.impp.framework.base.controller.MesBaseController;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping(CommonConstWords.BASE_URL_MES)
@Api(tags = "作业时间月绩报表控制层")
public class SxWorkingTimeMonthlyPerformanceController extends MesBaseController {

    @Autowired
    private ISxWorkingTimeMonthlyPerformanceService workingTimeMonthlyPerformanceService;

    @PostMapping(value = "/sx/ext/work-time-monthly-performance/query")
    @ApiOperation(value = "作业时间月绩报表")
    public ResultBean queryWorkingTimeMonthlyPerformance(@RequestBody SxWorkingTimeMonthlyPerformanceModel data) {
        try {
            ValidatorBean.beginValid(data)
                    .notNull(MesExtConstWords.DIMENSION, data.getDimension())
                    .notNull(MesExtConstWords.DIMENSION_1, data.getDimension1())
                    .notNull(MesExtConstWords.WORK_TIME_START, data.getWorkTimeStart())
                    .notNull(MesExtConstWords.WORK_TIME_END, data.getWorkTimeEnd());
            data.setOrganizeCode(AuthUtil.getOrganize().getOrganizeCode());
            return ResultBean.success("查询成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode())
                    .setResultObject(workingTimeMonthlyPerformanceService.queryWorkingTimeMonthlyPerformance(data));
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

}
